VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cExportCsv"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements iExport

Private mFileName As String
Private mRs As RC6.cRecordset
Const mFilter As String = "CSV (*.csv)|*.csv"
Const mExtension As String = ".csv"

Private Function iExport_GetData(Settings As RC6.cHashD) As Byte()
Dim tmpl As String, delimiter As String
Dim fields() As String
Dim i As Integer
Dim sb As cStringBuilder

    Set sb = New_c.StringBuilder
    tmpl = Settings("template")
    If InStr(tmpl, "{tab}") Then
        delimiter = "{tab}"
    ElseIf InStr(tmpl, ">;<") Then
        delimiter = ";"
    ElseIf InStr(tmpl, ">,<") Then
        delimiter = ","
    End If
    fields = Split(tmpl, delimiter)

    If delimiter = "{tab}" Then delimiter = vbTab
    With sb
        If Not mRs Is Nothing Then
          Do Until mRs.EOF
            For i = 0 To UBound(fields)
                Select Case fields(i)
                    Case "<kz>":       .AddNL mRs!kuerzel, delimiter
                    Case "<name>":     .AddNL mRs!name, delimiter
                    Case "<datum>":    .AddNL CDate(mRs!id_kalender), delimiter
                End Select
            Next i
            .Add vbCrLf
            mRs.MoveNext
          Loop
        End If
        iExport_GetData = .ToUTF8
    End With
End Function

Private Property Let iExport_FileName(RHS As String)
    mFileName = RHS
    If Right$(LCase$(mFileName), Len(mExtension)) <> mExtension Then mFileName = mFileName & mExtension
End Property

Private Property Get iExport_FileExtension() As String
    iExport_FileExtension = mExtension
End Property

Private Property Get iExport_FileName() As String
    iExport_FileName = mFileName
End Property

Private Property Set iExport_Legende(RHS As RC6.cRecordset)
End Property

Private Property Get iExport_Legende() As RC6.cRecordset
End Property

Private Property Set iExport_Recordset(RHS As RC6.cRecordset)
    Set mRs = RHS
End Property

Private Property Get iExport_Recordset() As RC6.cRecordset
    Set iExport_Recordset = mRs
End Property

Private Property Get iExport_Filter() As String
    iExport_Filter = mFilter
End Property


